5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
17 . "${source_path}/build/make/configure.sh"
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 --libc=PATH path to alternate libc
26 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
27 ${toggle_fast_unaligned} don't use unaligned accesses, even when
28 supported by hardware [auto]
29 ${toggle_codec_srcs} in/exclude codec library source code
30 ${toggle_debug_libs} in/exclude debug version of libraries
31 ${toggle_md5} support for output of checksum data
32 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
33 ${toggle_vp8} VP8 codec support
34 ${toggle_psnr} output of PSNR data, if supported (encoders)
35 ${toggle_mem_tracker} track memory usage
36 ${toggle_postproc} postprocessing
37 ${toggle_multithread} multithreaded encoding and decoding.
38 ${toggle_spatial_resampling} spatial sampling (scaling) support
39 ${toggle_realtime_only} enable this option while building for real-time encoding
40 ${toggle_runtime_cpu_detect} runtime cpu detection
41 ${toggle_shared} shared library support
42 ${toggle_small} favor smaller size over speed
43 ${toggle_arm_asm_detok} assembly version of the detokenizer (ARM platforms only)
44 ${toggle_postproc_visualizer} macro block / block level visualizers
47 Codecs can be selectively enabled or disabled individually, or by family:
50 --disable-<codec>-encoder
51 --disable-<codec>-decoder
53 Codecs available in this distribution:
55 #restore editor state '
61 for c in ${CODECS}; do
63 if [ "${family}" != "${last_family}" ]; then
64 [ -z "${str}" ] || echo "${str}"
65 str="$(printf ' %10s:' ${family})"
67 str="${str} $(printf '%10s' ${c#*_})"
75 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
78 # all_platforms is a list of all supported target platforms. Maintain
79 # alphabetically by architecture, generic-gnu last.
80 all_platforms="${all_platforms} armv5te-linux-rvct"
81 all_platforms="${all_platforms} armv5te-linux-gcc"
82 all_platforms="${all_platforms} armv5te-symbian-gcc"
83 all_platforms="${all_platforms} armv5te-wince-vs8"
84 all_platforms="${all_platforms} armv6-darwin-gcc"
85 all_platforms="${all_platforms} armv6-linux-rvct"
86 all_platforms="${all_platforms} armv6-linux-gcc"
87 all_platforms="${all_platforms} armv6-symbian-gcc"
88 all_platforms="${all_platforms} armv6-wince-vs8"
89 all_platforms="${all_platforms} iwmmxt-linux-rvct"
90 all_platforms="${all_platforms} iwmmxt-linux-gcc"
91 all_platforms="${all_platforms} iwmmxt-wince-vs8"
92 all_platforms="${all_platforms} iwmmxt2-linux-rvct"
93 all_platforms="${all_platforms} iwmmxt2-linux-gcc"
94 all_platforms="${all_platforms} iwmmxt2-wince-vs8"
95 all_platforms="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
96 all_platforms="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
97 all_platforms="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
98 all_platforms="${all_platforms} mips32-linux-gcc"
99 all_platforms="${all_platforms} ppc32-darwin8-gcc"
100 all_platforms="${all_platforms} ppc32-darwin9-gcc"
101 all_platforms="${all_platforms} ppc32-linux-gcc"
102 all_platforms="${all_platforms} ppc64-darwin8-gcc"
103 all_platforms="${all_platforms} ppc64-darwin9-gcc"
104 all_platforms="${all_platforms} ppc64-linux-gcc"
105 all_platforms="${all_platforms} sparc-solaris-gcc"
106 all_platforms="${all_platforms} x86-darwin8-gcc"
107 all_platforms="${all_platforms} x86-darwin8-icc"
108 all_platforms="${all_platforms} x86-darwin9-gcc"
109 all_platforms="${all_platforms} x86-darwin9-icc"
110 all_platforms="${all_platforms} x86-linux-gcc"
111 all_platforms="${all_platforms} x86-linux-icc"
112 all_platforms="${all_platforms} x86-solaris-gcc"
113 all_platforms="${all_platforms} x86-win32-gcc"
114 all_platforms="${all_platforms} x86-win32-vs7"
115 all_platforms="${all_platforms} x86-win32-vs8"
116 all_platforms="${all_platforms} x86-win32-vs9"
117 all_platforms="${all_platforms} x86_64-darwin9-gcc"
118 all_platforms="${all_platforms} x86_64-linux-gcc"
119 all_platforms="${all_platforms} x86_64-linux-icc"
120 all_platforms="${all_platforms} x86_64-solaris-gcc"
121 all_platforms="${all_platforms} x86_64-win64-vs8"
122 all_platforms="${all_platforms} x86_64-win64-vs9"
123 all_platforms="${all_platforms} universal-darwin8-gcc"
124 all_platforms="${all_platforms} universal-darwin9-gcc"
125 all_platforms="${all_platforms} generic-gnu"
127 # all_targets is a list of all targets that can be configured
128 # note that these should be in dependency order for now.
129 all_targets="libs examples docs"
131 # all targets available are enabled, by default.
132 for t in ${all_targets}; do
133 [ -f ${source_path}/${t}.mk ] && enable ${t}
136 # check installed doxygen version
137 doxy_version=$(doxygen --version 2>/dev/null)
138 doxy_major=${doxy_version%%.*}
139 if [ ${doxy_major:-0} -ge 1 ]; then
140 doxy_version=${doxy_version#*.}
141 doxy_minor=${doxy_version%%.*}
142 doxy_patch=${doxy_version##*.}
144 [ $doxy_major -gt 1 ] && enable doxygen
145 [ $doxy_minor -gt 5 ] && enable doxygen
146 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
149 # install everything except the sources, by default. sources will have
150 # to be enabled when doing dist builds, since that's no longer a common
152 enabled doxygen && php -v >/dev/null 2>&1 && enable install_docs
157 enable fast_unaligned #allow unaligned accesses, if supported by hw
159 enable spatial_resampling
162 [ -d ${source_path}/../include ] && enable alt_tree_layout
164 [ -d ${source_path}/${d} ] && disable alt_tree_layout;
167 if ! enabled alt_tree_layout; then
168 # development environment
169 [ -d ${source_path}/vp8 ] && CODECS="${CODECS} vp8_encoder vp8_decoder"
171 # customer environment
172 [ -f ${source_path}/../include/vpx/vp8cx.h ] && CODECS="${CODECS} vp8_encoder"
173 [ -f ${source_path}/../include/vpx/vp8dx.h ] && CODECS="${CODECS} vp8_decoder"
175 [ -f ${source_path}/../lib/*/*mt.lib ] && soft_enable static_msvcrt
178 CODECS="$(echo ${CODECS} | tr ' ' '\n')"
179 CODEC_FAMILIES="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
301 --disable-codecs) for c in ${CODECS}; do disable $c; done ;;
302 *) process_common_cmdline $opt
308 post_process_cmdline() {
311 # If the codec family is disabled, disable all components of that family.
312 # If the codec family is enabled, enable all components of that family.
313 log_echo "Configuring selected codecs"
314 for c in ${CODECS}; do
315 disabled ${c%%_*} && disable ${c}
316 enabled ${c%%_*} && enable ${c}
319 # Enable all detected codecs, if they haven't been disabled
320 for c in ${CODECS}; do soft_enable $c; done
322 # Enable the codec family if any component of that family is enabled
323 for c in ${CODECS}; do
324 enabled $c && enable ${c%_*}
327 # Set the {en,de}coders variable if any algorithm in that class is enabled
328 for c in ${CODECS}; do
329 enabled ${c} && enable ${c##*_}s
335 enabled child || write_common_config_banner
336 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
338 # TODO: add host tools target (obj_int_extract, etc)
340 # For fat binaries, call configure recursively to configure for each
341 # binary architecture to be included.
342 if enabled universal; then
343 # Call configure (ourselves) for each subarchitecture
344 for arch in $fat_bin_archs; do
345 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
349 # The write_common_config (config.mk) logic is deferred until after the
350 # recursive calls to configure complete, becuase we want our universal
351 # targets to be executed last.
352 write_common_config_targets
353 enabled universal && echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
355 # Calculate the default distribution name, based on the enabled features
358 for cf in $CODEC_FAMILIES; do
359 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
360 DIST_DIR="${DIST_DIR}-${cf}"
361 elif enabled ${cf}_encoder; then
362 DIST_DIR="${DIST_DIR}-${cf}cx"
363 elif enabled ${cf}_decoder; then
364 DIST_DIR="${DIST_DIR}-${cf}dx"
367 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
368 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
369 ! enabled postproc && DIST_DIR="${DIST_DIR}-nopost"
370 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
371 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
372 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
374 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt" || DIST_DIR="${DIST_DIR}md"
375 DIST_DIR="${DIST_DIR}-${tgt_cc}"
378 if [ -f "${source_path}/build/make/version.sh" ]; then
379 local ver=`"$source_path/build/make/version.sh" --bare $source_path`
380 DIST_DIR="${DIST_DIR}-${ver}"
382 VERSION_PATCH=${ver##*.}
384 VERSION_MINOR=${ver##*.}
386 VERSION_MAJOR=${ver%.*}
388 enabled child || cat <<EOF >> config.mk
389 ifeq (\$(MAKECMDGOALS),dist)
390 DIST_DIR?=${DIST_DIR}
392 DIST_DIR?=\$(DESTDIR)${prefix}
394 LIBSUBDIR=${libdir##${prefix}/}
396 VERSION_MAJOR=${VERSION_MAJOR}
397 VERSION_MINOR=${VERSION_MINOR}
398 VERSION_PATCH=${VERSION_PATCH}
400 CONFIGURE_ARGS=${CONFIGURE_ARGS}
402 enabled child || echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
405 # Write makefiles for all enabled targets
407 for tgt in libs examples docs solution; do
408 local tgt_fn="$tgt-$toolchain.mk"
410 if enabled $tgt; then
411 echo "Creating makefiles for ${toolchain} ${tgt}"
412 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
420 if enabled shared; then
421 # Can only build shared libs on a subset of platforms. Doing this check
422 # here rather than at option parse time because the target auto-detect
423 # magic happens after the command line has been parsed.
424 enabled linux || die "--enable-shared only supported on ELF for now"
426 if [ -z "$CC" ]; then
427 echo "Bypassing toolchain for environment detection."
428 enable external_build
430 log fake_check_header "$@"
433 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
442 [ -f "${d##-I}/$header" ] && result=true && break
451 check_header stdio.h || die "Unable to invoke compiler: ${CC} ${CFLAGS}"
452 check_ld <<EOF || die "Toolchain is unable to link executables"
453 int main(void) {return 0;}
455 # check system headers
456 check_header stdint.h
457 check_header pthread.h
458 check_header sys/mman.h
460 check_header vpx/vpx_integer.h -I${source_path} && enable vpx_ports
463 process_toolchain() {
464 process_common_toolchain
466 # Handle universal binaries for this architecture
469 local darwin_ver=${tgt_os##darwin}
470 fat_bin_archs="$fat_bin_archs ppc32-${tgt_os}-gcc"
473 fat_bin_archs="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
474 if [ $darwin_ver -gt 8 ]; then
475 fat_bin_archs="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
481 # Enable some useful compiler flags
483 enabled werror && check_add_cflags -Werror
484 check_add_cflags -Wall
485 check_add_cflags -Wdeclaration-after-statement
486 check_add_cflags -Wdisabled-optimization
487 check_add_cflags -Wpointer-arith
488 check_add_cflags -Wtype-limits
489 check_add_cflags -Wcast-qual
490 enabled extra_warnings || check_add_cflags -Wno-unused
494 enabled werror && check_add_cflags -Werror
495 check_add_cflags -Wall
496 check_add_cflags -Wpointer-arith
498 # ICC has a number of floating point optimizations that we disable
499 # in favor of deterministic output WRT to other compilers
500 add_cflags -fp-model precise
503 # Enable extra, harmless warnings. These might provide additional insight
504 # to what the compiler is doing and why, but in general, but they shouldn't
505 # be treated as fatal, even if we're treating warnings as errors.
507 -Wdisabled-optimization
510 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
511 RVCT_EXTRA_WARNINGS="
514 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
515 if enabled extra_warnings; then
516 for w in ${EXTRA_WARNINGS}; do
517 check_add_cflags ${w}
518 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
522 # ccache only really works on gcc toolchains
523 enabled gcc || soft_disable ccache
524 if enabled mips; then
525 enable dequant_tokens
529 # Enable the postbuild target if building for visual studio.
533 vs_version=${tgt_cc##vs}
534 all_targets="${all_targets} solution"
538 # Other toolchain specific defaults
539 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
541 enabled postproc_visualizer && {enabled postproc \
542 || die "postproc_visualizer requires postproc to be enabled"}
547 ## END APPLICATION SPECIFIC CONFIGURATION
551 cat <<EOF > ${BUILD_PFX}vpx_config.c
552 static const char* const cfg = "$CONFIGURE_ARGS";
553 const char *vpx_codec_build_config(void) {return cfg;}